#ifndef _EDGE_H_
#define _EDGE_H_

#include <string>

class HalfEdge;
class Vertex;

class Edge
{
public:
	Edge()
	{
		m_halfedge[0]=NULL; 
		m_halfedge[1]=NULL;
		m_vertices[0] = -1;
		m_vertices[1] = -1;
	}

	Edge(int vertID1, int vertID2)
	{
		m_halfedge[0]=NULL; 
		m_halfedge[1]=NULL;
		m_vertices[0] = vertID1;
		m_vertices[1] = vertID2;
	}
	
	~Edge(){;}

	HalfEdge * & halfedge( int i ) { return m_halfedge[i];}
	
	int & vid(int i) { return m_vertices[i]; }
	
	bool boundary() { return (m_halfedge[0] && !(m_halfedge[1])) || (!(m_halfedge[0]) && m_halfedge[1] ); }
		
	std::string & PropertyStr() { return m_propertyStr;}
	
	HalfEdge * & twin( HalfEdge * he ) { return (he != m_halfedge[0] )?m_halfedge[0]:m_halfedge[1]; }
	
	bool operator== (const Edge & e) const
    {
		int rid0 = e.m_vertices[0];
		int rid1 = e.m_vertices[1];
		if (m_vertices[0] == rid0 && m_vertices[1] == rid1)
			return true;
		else if (m_vertices[1] == rid0 && m_vertices[0] == rid1)
			return true;
		return false;
    }

protected:	
	//for halfedge data structure
	HalfEdge	*	m_halfedge[2];

	//additionally
	int				m_vertices[2];
	std::string		m_propertyStr;
};

#endif