#include <iostream>
#include <set>
#include <queue>
#include <map>
#include <vector>
#include "MeshLib\Mesh.h"
#include "MeshLib\Iterators.h"
#include "CutGraph.h"

using namespace std;

int main(int argc, char **argv)
{
	if(argc <3){
		cerr << "format: CutGraph in.m out.txt" << endl;
		exit(0);
	}
	Mesh *cmesh = new Mesh;
	cmesh->read(argv[1]);
	CutGraph cg(cmesh);

	cg.ComputeDualGraph();
	cg.ComputeSpanningTree();
	cg.TopoCut();
	cg.TrimDanglingEdge(argv[2]);
	cg.ComputeFundamentalDomain("fd_star.m");

	delete cmesh;

	return 0;
}