#ifndef __Application_H
#define __Application_H

#include "Core_Mesh/Mesh.h"
#include "Core_Mesh/HalfEdge.h"
#include "NumericalRecipe/x_nrcpp.h"
#include "Texture/Texture.h"

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "Core_Mesh/Mesh.h"
#include "Core_Mesh/Curve.h"

using namespace XMeshLib;
// put your global typedefs here
#define PI 3.1415926535897932384626
class Application 
{

public:
	Application();
	~Application(){;}

	void ReadSourceMesh();
	void ReadTargetMesh();

	// put your application prototypes here: 
	void WriteMesh();

	void HarmMap(Mesh *theMesh);
    void Morphing ();

	void Baycentry (Point puv,Point &nvp,Point &nvpnormal,double rgb[3],bool bf);
	int PointLocation (Face*&face,double bary[3],Point puv);
	int TestPointTriangle (Point p, Point a, Point b, Point c,double bary[3]);
	Curve *ctb;   //we are going to create a curve for the target boundary

	void Init ();
	void ClearMapping();
	void ComputeCoefMatrix();
	void ComputeLamda (Mesh *theMesh);
	bool Neighbor (int i,int j); //judge j is in i's neighbor, then return true
	float GetLamda (int i,int j);  //return -lamda(i,j)
	double CalcuateL (Mesh *theMesh,int i,int j);
	double CornerAngle (XMeshLib::HalfEdge * he);
	int FIndindex (int j);

	void SVDCoefMatrix_Nrcpp();


	//XMeshLib::Mesh * theMesh;
	XMeshLib::Mesh * sMesh;
	XMeshLib::Mesh * tMesh;

	std::vector <std::vector<float>> Lamda;  // all the points weight
	std::vector <std::vector<int>> NeighLam; // store all the neighbor's information in here, corresponding to the lamda's order
	float ** mat_A;  //the interior points matrix
	float ** mat_v; //these two used for SVD decomposition
	float * vec_w;

	float * vec_X1;  //the interior points u
	float * vec_X2;  //the interior points v
	float * vec_U;   //boundary condition
	float * vec_V;
	float * vec_B1;
	float * vec_B2;

	int *indexvin; //the set each vertex a index, through this indexv to find its corresponding u,v in nonboundary(vec_X1, vec_X2), or boundary(vec_U, vec_V)
	int *indexvb;  //index for boundary points
	bool *boundaryv; //mark whether this vertex has been used for boundary condition, if it is, then find its corresponding in vec_U, vec_V

	int nb;  //boundary points number
	int inp; //interior points number
	int vn;  //all vertex number



};

#endif
