//=============================================================================
//
//  Implements the class for 3D Rigid Rotation
//
//=============================================================================


#ifndef _XMESHLIB_3DROTATION_H
#define _XMESHLIB_3DROTATION_H

//=== INCLUDES ================================================================

#include <cmath>
#include <cassert>
#include "../Core_Mesh/Point.h"
//#include "../Core/Common.h"

//== DEFINITION ===============================================================

//=== IMPLEMENTATION ==========================================================

namespace XMeshLib
{
	class Rotation3D
	{		
	public:
		static Point Rotate(Point & oldVec, double theta1, double theta2, double theta3)
		{
			//rotate along z-axis
			double x = oldVec[0] * cos(theta3) - oldVec[1] * sin(theta3);
			double y = oldVec[0] * sin(theta3) + oldVec[1] * cos(theta3);
			double z = oldVec[2];
			//rotate along x-axis
			y = y * cos(theta1) - z * sin(theta1);
			z = y * sin(theta1) + z * cos(theta1);
			//x = x;
			//rotate along y-axis
			z = z * cos(theta2) - x * sin(theta2);
			x = z * sin(theta2) + x * cos(theta2);
			//y = y;
			Point np(x,y,z);
			return np;
		}
	};
}
#endif